Package javax.servlet.http

## Interface HttpServletResponse

All Superinterfaces:
  `ServletResponse`

All Known Implementing Classes:
  `HttpServletResponseWrapper`

    public interface HttpServletResponse
    extends ServletResponse

Extends the `ServletResponse` interface to provide HTTP-specific functionality in sending a response. For example, it has methods to access HTTP headers and cookies.

The servlet container creates an `HttpServletResponse` object and passes it as an argument to the servlet's service methods (`doGet`, `doPost`, etc).

See Also:
  `ServletResponse`

### Field Summary

Fields
`static int` `SC_ACCEPTED` Status code (202) indicating that a request was accepted for processing, but was not completed.
`static int` `SC_BAD_GATEWAY` Status code (502) indicating that the HTTP server received an invalid response from a server it consulted when acting as a proxy or gateway.
`static int` `SC_BAD_REQUEST` Status code (400) indicating the request sent by the client was syntactically incorrect.
`static int` `SC_CONFLICT` Status code (409) indicating that the request could not be completed due to a conflict with the current state of the resource.
`static int` `SC_CONTINUE` Status code (100) indicating the client can continue.
`static int` `SC_CREATED` Status code (201) indicating the request succeeded and created a new resource on the server.
`static int` `SC_EXPECTATION_FAILED` Status code (417) indicating that the server could not meet the expectation given in the Expect request header.
`static int` `SC_FORBIDDEN` Status code (403) indicating the server understood the request but refused to fulfill it.
`static int` `SC_FOUND` Status code (302) indicating that the resource reside temporarily under a different URI.
`static int` `SC_GATEWAY_TIMEOUT` Status code (504) indicating that the server did not receive a timely response from the upstream server while acting as a gateway or proxy.
`static int` `SC_GONE` Status code (410) indicating that the resource is no longer available at the server and no forwarding address is known.
`static int` `SC_HTTP_VERSION_NOT_SUPPORTED` Status code (505) indicating that the server does not support or refuses to support the HTTP protocol version that was used in the request message.
`static int` `SC_INTERNAL_SERVER_ERROR` Status code (500) indicating an error inside the HTTP server which prevented it from fulfilling the request.
`static int` `SC_LENGTH_REQUIRED` Status code (411) indicating that the request cannot be handled without a defined `Content-Length`.
`static int` `SC_METHOD_NOT_ALLOWED` Status code (405) indicating that the method specified in the `Request-Line` is not allowed for the resource identified by the `Request-URI`.
`static int` `SC_MOVED_PERMANENTLY` Status code (301) indicating that the resource has permanently moved to a new location, and that future references should use a new URI with their requests.
`static int` `SC_MOVED_TEMPORARILY` Status code (302) indicating that the resource has temporarily moved to another location, but that future references should still use the original URI to access the resource.
`static int` `SC_MULTIPLE_CHOICES` Status code (300) indicating that the requested resource corresponds to any one of a set of representations, each with its own specific location.
`static int` `SC_NO_CONTENT` Status code (204) indicating that the request succeeded but that there was no new information to return.
`static int` `SC_NON_AUTHORITATIVE_INFORMATION` Status code (203) indicating that the meta information presented by the client did not originate from the server.
`static int` `SC_NOT_ACCEPTABLE` Status code (406) indicating that the resource identified by the request is only capable of generating response entities which have content characteristics not acceptable according to the accept headers sent in the request.
`static int` `SC_NOT_FOUND` Status code (404) indicating that the requested resource is not available.
`static int` `SC_NOT_IMPLEMENTED` Status code (501) indicating the HTTP server does not support the functionality needed to fulfill the request.
`static int` `SC_NOT_MODIFIED` Status code (304) indicating that a conditional GET operation found that the resource was available and not modified.
`static int` `SC_OK` Status code (200) indicating the request succeeded normally.
`static int` `SC_PARTIAL_CONTENT` Status code (206) indicating that the server has fulfilled the partial GET request for the resource.
`static int` `SC_PAYMENT_REQUIRED` Status code (402) reserved for future use.
`static int` `SC_PRECONDITION_FAILED` Status code (412) indicating that the precondition given in one or more of the request-header fields evaluated to false when it was tested on the server.
`static int` `SC_PROXY_AUTHENTICATION_REQUIRED` Status code (407) indicating that the client MUST first authenticate itself with the proxy.
`static int` `SC_REQUEST_ENTITY_TOO_LARGE` Status code (413) indicating that the server is refusing to process the request because the request entity is larger than the server is willing or able to process.
`static int` `SC_REQUEST_TIMEOUT` Status code (408) indicating that the client did not produce a request within the time that the server was prepared to wait.
`static int` `SC_REQUEST_URI_TOO_LONG` Status code (414) indicating that the server is refusing to service the request because the `Request-URI` is longer than the server is willing to interpret.
`static int` `SC_REQUESTED_RANGE_NOT_SATISFIABLE` Status code (416) indicating that the server cannot serve the requested byte range.
`static int` `SC_RESET_CONTENT` Status code (205) indicating that the agent SHOULD reset the document view which caused the request to be sent.
`static int` `SC_SEE_OTHER` Status code (303) indicating that the response to the request can be found under a different URI.
`static int` `SC_SERVICE_UNAVAILABLE` Status code (503) indicating that the HTTP server is temporarily overloaded, and unable to handle the request.
`static int` `SC_SWITCHING_PROTOCOLS` Status code (101) indicating the server is switching protocols according to Upgrade header.
`static int` `SC_TEMPORARY_REDIRECT` Status code (307) indicating that the requested resource resides temporarily under a different URI.
`static int` `SC_UNAUTHORIZED` Status code (401) indicating that the request requires HTTP authentication.
`static int` `SC_UNSUPPORTED_MEDIA_TYPE` Status code (415) indicating that the server is refusing to service the request because the entity of the request is in a format not supported by the requested resource for the requested method.
`static int` `SC_USE_PROXY` Status code (305) indicating that the requested resource MUST be accessed through the proxy given by the `Location` field.

### Method Summary

All Methods Instance Methods Abstract Methods Deprecated Methods
`void` `addCookie​(Cookie cookie)` Adds the specified cookie to the response.
`void` `addDateHeader​(java.lang.String name, long date)` Adds a response header with the given name and date-value.
`void` `addHeader​(java.lang.String name, java.lang.String value)` Adds a response header with the given name and value.
`void` `addIntHeader​(java.lang.String name, int value)` Adds a response header with the given name and integer value.
`boolean` `containsHeader​(java.lang.String name)` Returns a boolean indicating whether the named response header has already been set.
`java.lang.String` `encodeRedirectUrl​(java.lang.String url)` Deprecated. As of version 2.1, use encodeRedirectURL(String url) instead
`java.lang.String` `encodeRedirectURL​(java.lang.String url)` Encodes the specified URL for use in the `sendRedirect` method or, if encoding is not needed, returns the URL unchanged.
`java.lang.String` `encodeUrl​(java.lang.String url)` Deprecated. As of version 2.1, use encodeURL(String url) instead
`java.lang.String` `encodeURL​(java.lang.String url)` Encodes the specified URL by including the session ID in it, or, if encoding is not needed, returns the URL unchanged.
`java.lang.String` `getHeader​(java.lang.String name)` Return the value for the specified header, or `null` if this header has not been set.
`java.util.Collection<java.lang.String>` `getHeaderNames()` Get the header names set for this HTTP response.
`java.util.Collection<java.lang.String>` `getHeaders​(java.lang.String name)` Return a Collection of all the header values associated with the specified header name.
`int` `getStatus()` Get the HTTP status code for this Response.
`void` `sendError​(int sc)` Sends an error response to the client using the specified status code and clears the buffer.
`void` `sendError​(int sc, java.lang.String msg)` Sends an error response to the client using the specified status code and clears the output buffer.
`void` `sendRedirect​(java.lang.String location)` Sends a temporary redirect response to the client using the specified redirect location URL.
`void` `setDateHeader​(java.lang.String name, long date)` Sets a response header with the given name and date-value.
`void` `setHeader​(java.lang.String name, java.lang.String value)` Sets a response header with the given name and value.
`void` `setIntHeader​(java.lang.String name, int value)` Sets a response header with the given name and integer value.
`void` `setStatus​(int sc)` Sets the status code for this response.
`void` `setStatus​(int sc, java.lang.String sm)` Deprecated. As of version 2.1, due to ambiguous meaning of the message parameter.

### Methods inherited from interface javax.servlet.ServletResponse

`flushBuffer, getBufferSize, getCharacterEncoding, getContentType, getLocale, getOutputStream, getWriter, isCommitted, reset, resetBuffer, setBufferSize, setCharacterEncoding, setContentLength, setContentLengthLong, setContentType, setLocale`

### Field Detail

#### SC_CONTINUE

    static final int SC_CONTINUE

Status code (100) indicating the client can continue.

See Also:
  Constant Field Values

#### SC_SWITCHING_PROTOCOLS

    static final int SC_SWITCHING_PROTOCOLS

Status code (101) indicating the server is switching protocols according to Upgrade header.

See Also:
  Constant Field Values

#### SC_OK

    static final int SC_OK

Status code (200) indicating the request succeeded normally.

See Also:
  Constant Field Values

#### SC_CREATED

    static final int SC_CREATED

Status code (201) indicating the request succeeded and created a new resource on the server.

See Also:
  Constant Field Values

#### SC_ACCEPTED

    static final int SC_ACCEPTED

Status code (202) indicating that a request was accepted for processing, but was not completed.

See Also:
  Constant Field Values

#### SC_NON_AUTHORITATIVE_INFORMATION

    static final int SC_NON_AUTHORITATIVE_INFORMATION

Status code (203) indicating that the meta information presented by the client did not originate from the server.

See Also:
  Constant Field Values

#### SC_NO_CONTENT

    static final int SC_NO_CONTENT

Status code (204) indicating that the request succeeded but that there was no new information to return.

See Also:
  Constant Field Values

#### SC_RESET_CONTENT

    static final int SC_RESET_CONTENT

Status code (205) indicating that the agent SHOULD reset the document view which caused the request to be sent.

See Also:
  Constant Field Values

#### SC_PARTIAL_CONTENT

    static final int SC_PARTIAL_CONTENT

Status code (206) indicating that the server has fulfilled the partial GET request for the resource.

See Also:
  Constant Field Values

#### SC_MULTIPLE_CHOICES

    static final int SC_MULTIPLE_CHOICES

Status code (300) indicating that the requested resource corresponds to any one of a set of representations, each with its own specific location.

See Also:
  Constant Field Values

#### SC_MOVED_PERMANENTLY

    static final int SC_MOVED_PERMANENTLY

Status code (301) indicating that the resource has permanently moved to a new location, and that future references should use a new URI with their requests.

See Also:
  Constant Field Values

#### SC_MOVED_TEMPORARILY

    static final int SC_MOVED_TEMPORARILY

Status code (302) indicating that the resource has temporarily moved to another location, but that future references should still use the original URI to access the resource. This definition is being retained for backwards compatibility. SC_FOUND is now the preferred definition.

See Also:
  Constant Field Values

#### SC_FOUND

    static final int SC_FOUND

Status code (302) indicating that the resource reside temporarily under a different URI. Since the redirection might be altered on occasion, the client should continue to use the Request-URI for future requests.(HTTP/1.1) To represent the status code (302), it is recommended to use this variable.

See Also:
  Constant Field Values

#### SC_SEE_OTHER

    static final int SC_SEE_OTHER

Status code (303) indicating that the response to the request can be found under a different URI.

See Also:
  Constant Field Values

#### SC_NOT_MODIFIED

    static final int SC_NOT_MODIFIED

Status code (304) indicating that a conditional GET operation found that the resource was available and not modified.

See Also:
  Constant Field Values

#### SC_USE_PROXY

    static final int SC_USE_PROXY

Status code (305) indicating that the requested resource MUST be accessed through the proxy given by the `Location` field.

See Also:
  Constant Field Values

#### SC_TEMPORARY_REDIRECT

    static final int SC_TEMPORARY_REDIRECT

Status code (307) indicating that the requested resource resides temporarily under a different URI. The temporary URI SHOULD be given by the `Location` field in the response.

See Also:
  Constant Field Values

#### SC_BAD_REQUEST

    static final int SC_BAD_REQUEST

Status code (400) indicating the request sent by the client was syntactically incorrect.

See Also:
  Constant Field Values

#### SC_UNAUTHORIZED

    static final int SC_UNAUTHORIZED

Status code (401) indicating that the request requires HTTP authentication.

See Also:
  Constant Field Values

#### SC_PAYMENT_REQUIRED

    static final int SC_PAYMENT_REQUIRED

Status code (402) reserved for future use.

See Also:
  Constant Field Values

#### SC_FORBIDDEN

    static final int SC_FORBIDDEN

Status code (403) indicating the server understood the request but refused to fulfill it.

See Also:
  Constant Field Values

#### SC_NOT_FOUND

    static final int SC_NOT_FOUND

Status code (404) indicating that the requested resource is not available.

See Also:
  Constant Field Values

#### SC_METHOD_NOT_ALLOWED

    static final int SC_METHOD_NOT_ALLOWED

Status code (405) indicating that the method specified in the `Request-Line` is not allowed for the resource identified by the `Request-URI`.

See Also:
  Constant Field Values

#### SC_NOT_ACCEPTABLE

    static final int SC_NOT_ACCEPTABLE

Status code (406) indicating that the resource identified by the request is only capable of generating response entities which have content characteristics not acceptable according to the accept headers sent in the request.

See Also:
  Constant Field Values

#### SC_PROXY_AUTHENTICATION_REQUIRED

    static final int SC_PROXY_AUTHENTICATION_REQUIRED

Status code (407) indicating that the client MUST first authenticate itself with the proxy.

See Also:
  Constant Field Values

#### SC_REQUEST_TIMEOUT

    static final int SC_REQUEST_TIMEOUT

Status code (408) indicating that the client did not produce a request within the time that the server was prepared to wait.

See Also:
  Constant Field Values

#### SC_CONFLICT

    static final int SC_CONFLICT

Status code (409) indicating that the request could not be completed due to a conflict with the current state of the resource.

See Also:
  Constant Field Values

#### SC_GONE

    static final int SC_GONE

Status code (410) indicating that the resource is no longer available at the server and no forwarding address is known. This condition SHOULD be considered permanent.

See Also:
  Constant Field Values

#### SC_LENGTH_REQUIRED

    static final int SC_LENGTH_REQUIRED

Status code (411) indicating that the request cannot be handled without a defined `Content-Length`.

See Also:
  Constant Field Values

#### SC_PRECONDITION_FAILED

    static final int SC_PRECONDITION_FAILED

Status code (412) indicating that the precondition given in one or more of the request-header fields evaluated to false when it was tested on the server.

See Also:
  Constant Field Values

#### SC_REQUEST_ENTITY_TOO_LARGE

    static final int SC_REQUEST_ENTITY_TOO_LARGE

Status code (413) indicating that the server is refusing to process the request because the request entity is larger than the server is willing or able to process.

See Also:
  Constant Field Values

#### SC_REQUEST_URI_TOO_LONG

    static final int SC_REQUEST_URI_TOO_LONG

Status code (414) indicating that the server is refusing to service the request because the `Request-URI` is longer than the server is willing to interpret.

See Also:
  Constant Field Values

#### SC_UNSUPPORTED_MEDIA_TYPE

    static final int SC_UNSUPPORTED_MEDIA_TYPE

Status code (415) indicating that the server is refusing to service the request because the entity of the request is in a format not supported by the requested resource for the requested method.

See Also:
  Constant Field Values

#### SC_REQUESTED_RANGE_NOT_SATISFIABLE

    static final int SC_REQUESTED_RANGE_NOT_SATISFIABLE

Status code (416) indicating that the server cannot serve the requested byte range.

See Also:
  Constant Field Values

#### SC_EXPECTATION_FAILED

    static final int SC_EXPECTATION_FAILED

Status code (417) indicating that the server could not meet the expectation given in the Expect request header.

See Also:
  Constant Field Values

#### SC_INTERNAL_SERVER_ERROR

    static final int SC_INTERNAL_SERVER_ERROR

Status code (500) indicating an error inside the HTTP server which prevented it from fulfilling the request.

See Also:
  Constant Field Values

#### SC_NOT_IMPLEMENTED

    static final int SC_NOT_IMPLEMENTED

Status code (501) indicating the HTTP server does not support the functionality needed to fulfill the request.

See Also:
  Constant Field Values

#### SC_BAD_GATEWAY

    static final int SC_BAD_GATEWAY

Status code (502) indicating that the HTTP server received an invalid response from a server it consulted when acting as a proxy or gateway.

See Also:
  Constant Field Values

#### SC_SERVICE_UNAVAILABLE

    static final int SC_SERVICE_UNAVAILABLE

Status code (503) indicating that the HTTP server is temporarily overloaded, and unable to handle the request.

See Also:
  Constant Field Values

#### SC_GATEWAY_TIMEOUT

    static final int SC_GATEWAY_TIMEOUT

Status code (504) indicating that the server did not receive a timely response from the upstream server while acting as a gateway or proxy.

See Also:
  Constant Field Values

#### SC_HTTP_VERSION_NOT_SUPPORTED

    static final int SC_HTTP_VERSION_NOT_SUPPORTED

Status code (505) indicating that the server does not support or refuses to support the HTTP protocol version that was used in the request message.

See Also:
  Constant Field Values

### Method Detail

#### addCookie

    void addCookie​(Cookie cookie)

Adds the specified cookie to the response. This method can be called multiple times to set more than one cookie.

Parameters:
  `cookie` - the Cookie to return to the client

#### containsHeader

    boolean containsHeader​(java.lang.String name)

Returns a boolean indicating whether the named response header has already been set.

Parameters:
  `name` - the header name
Returns:
  `true` if the named response header has already been set; `false` otherwise

#### encodeURL

    java.lang.String encodeURL​(java.lang.String url)

Encodes the specified URL by including the session ID in it, or, if encoding is not needed, returns the URL unchanged. The implementation of this method includes the logic to determine whether the session ID needs to be encoded in the URL. For example, if the browser supports cookies, or session tracking is turned off, URL encoding is unnecessary.

For robust session tracking, all URLs emitted by a servlet should be run through this method. Otherwise, URL rewriting cannot be used with browsers which do not support cookies.

Parameters:
  `url` - the url to be encoded.
Returns:
  the encoded URL if encoding is needed; the unchanged URL otherwise.

#### encodeRedirectURL

    java.lang.String encodeRedirectURL​(java.lang.String url)

Encodes the specified URL for use in the `sendRedirect` method or, if encoding is not needed, returns the URL unchanged. The implementation of this method includes the logic to determine whether the session ID needs to be encoded in the URL. Because the rules for making this determination can differ from those used to decide whether to encode a normal link, this method is separated from the `encodeURL` method.

All URLs sent to the `HttpServletResponse.sendRedirect` method should be run through this method. Otherwise, URL rewriting cannot be used with browsers which do not support cookies.

Parameters:
  `url` - the url to be encoded.
Returns:
  the encoded URL if encoding is needed; the unchanged URL otherwise.
See Also:
  `sendRedirect(java.lang.String)`, `encodeUrl(java.lang.String)`

#### encodeUrl

    java.lang.String encodeUrl​(java.lang.String url)

Deprecated.
As of version 2.1, use encodeURL(String url) instead

Parameters:
  `url` - the url to be encoded.
Returns:
  the encoded URL if encoding is needed; the unchanged URL otherwise.

#### encodeRedirectUrl

    java.lang.String encodeRedirectUrl​(java.lang.String url)

Deprecated.
As of version 2.1, use encodeRedirectURL(String url) instead

Parameters:
  `url` - the url to be encoded.
Returns:
  the encoded URL if encoding is needed; the unchanged URL otherwise.

#### sendError

    void sendError​(int sc,
                   java.lang.String msg)
            throws java.io.IOException

Sends an error response to the client using the specified status code and clears the output buffer. The server defaults to creating the response to look like an HTML-formatted server error page containing the specified message, setting the content type to "text/html", leaving cookies and other headers unmodified. If an error-page declaration has been made for the web application corresponding to the status code passed in, it will be served back in preference to the suggested msg parameter.

If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.

Parameters:
  `sc` - the error status code
  `msg` - the descriptive message
Throws:
  `java.io.IOException` - If an input or output exception occurs
  `java.lang.IllegalStateException` - If the response was committed

#### sendError

    void sendError​(int sc)
            throws java.io.IOException

Sends an error response to the client using the specified status code and clears the buffer. This is equivalent to calling `sendError(int, String)` with the same status code and `null` for the message.

Parameters:
  `sc` - the error status code
Throws:
  `java.io.IOException` - If an input or output exception occurs
  `java.lang.IllegalStateException` - If the response was committed before this method call

#### sendRedirect

    void sendRedirect​(java.lang.String location)
               throws java.io.IOException

Sends a temporary redirect response to the client using the specified redirect location URL. This method can accept relative URLs; the servlet container must convert the relative URL to an absolute URL before sending the response to the client. If the location is relative without a leading '/' the container interprets it as relative to the current request URI. If the location is relative with a leading '/' the container interprets it as relative to the servlet container root.

If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.

Parameters:
  `location` - the redirect location URL
Throws:
  `java.io.IOException` - If an input or output exception occurs
  `java.lang.IllegalStateException` - If the response was committed or if a partial URL is given and cannot be converted into a valid URL

#### setDateHeader

    void setDateHeader​(java.lang.String name,
                       long date)

Sets a response header with the given name and date-value. The date is specified in terms of milliseconds since the epoch. If the header had already been set, the new value overwrites the previous one. The `containsHeader` method can be used to test for the presence of a header before setting its value.

Parameters:
  `name` - the name of the header to set
  `date` - the assigned date value
See Also:
  `containsHeader(java.lang.String)`, `addDateHeader(java.lang.String, long)`

#### addDateHeader

    void addDateHeader​(java.lang.String name,
                       long date)

Adds a response header with the given name and date-value. The date is specified in terms of milliseconds since the epoch. This method allows response headers to have multiple values.

Parameters:
  `name` - the name of the header to set
  `date` - the additional date value
See Also:
  `setDateHeader(java.lang.String, long)`

#### setHeader

    void setHeader​(java.lang.String name,
                   java.lang.String value)

Sets a response header with the given name and value. If the header had already been set, the new value overwrites the previous one. The `containsHeader` method can be used to test for the presence of a header before setting its value.

Parameters:
  `name` - the name of the header
  `value` - the header value If it contains octet string, it should be encoded according to RFC 2047 (http://www.ietf.org/rfc/rfc2047.txt)
See Also:
  `containsHeader(java.lang.String)`, `addHeader(java.lang.String, java.lang.String)`

#### addHeader

    void addHeader​(java.lang.String name,
                   java.lang.String value)

Adds a response header with the given name and value. This method allows response headers to have multiple values.

Parameters:
  `name` - the name of the header
  `value` - the additional header value If it contains octet string, it should be encoded according to RFC 2047 (http://www.ietf.org/rfc/rfc2047.txt)
See Also:
  `setHeader(java.lang.String, java.lang.String)`

#### setIntHeader

    void setIntHeader​(java.lang.String name,
                      int value)

Sets a response header with the given name and integer value. If the header had already been set, the new value overwrites the previous one. The `containsHeader` method can be used to test for the presence of a header before setting its value.

Parameters:
  `name` - the name of the header
  `value` - the assigned integer value
See Also:
  `containsHeader(java.lang.String)`, `addIntHeader(java.lang.String, int)`

#### addIntHeader

    void addIntHeader​(java.lang.String name,
                      int value)

Adds a response header with the given name and integer value. This method allows response headers to have multiple values.

Parameters:
  `name` - the name of the header
  `value` - the assigned integer value
See Also:
  `setIntHeader(java.lang.String, int)`

#### setStatus

    void setStatus​(int sc)

Sets the status code for this response. This method is used to set the return status code when there is no error (for example, for the status codes SC_OK or SC_MOVED_TEMPORARILY). If there is an error, and the caller wishes to invoke an error-page defined in the web application, the `sendError` method should be used instead.

The container clears the buffer and sets the Location header, preserving cookies and other headers.

Parameters:
  `sc` - the status code
See Also:
  `sendError(int, java.lang.String)`

#### setStatus

    void setStatus​(int sc,
                   java.lang.String sm)

Deprecated.
As of version 2.1, due to ambiguous meaning of the message parameter. To set a status code use `setStatus(int)`, to send an error with a description use `sendError(int, String)`.
Sets the status code and message for this response.

Parameters:
  `sc` - the status code
  `sm` - the status message

#### getStatus

    int getStatus()

Get the HTTP status code for this Response.

Returns:
  The HTTP status code for this Response
Since:
  Servlet 3.0

#### getHeader

    java.lang.String getHeader​(java.lang.String name)

Return the value for the specified header, or `null` if this header has not been set. If more than one value was added for this name, only the first is returned; use `getHeaders(String)` to retrieve all of them.

Parameters:
  `name` - Header name to look up
Returns:
  The first value for the specified header. This is the raw value so if multiple values are specified in the first header then they will be returned as a single header value .
Since:
  Servlet 3.0

#### getHeaders

    java.util.Collection<java.lang.String> getHeaders​(java.lang.String name)

Return a Collection of all the header values associated with the specified header name.

Parameters:
  `name` - Header name to look up
Returns:
  The values for the specified header. These are the raw values so if multiple values are specified in a single header that will be returned as a single header value.
Since:
  Servlet 3.0

#### getHeaderNames

    java.util.Collection<java.lang.String> getHeaderNames()

Get the header names set for this HTTP response.

Returns:
  The header names set for this HTTP response.
Since:
  Servlet 3.0